------------------------------------------------------------
revno: 9826
revision-id: squid3@treenet.co.nz-20091216010125-npa9v932f8x4pv9z
parent: squid3@treenet.co.nz-20091216005917-97kq9m4r5whfqdft
committer: Amos Jeffries <squid3@treenet.co.nz>
branch nick: SQUID_3_1
timestamp: Wed 2009-12-16 14:01:25 +1300
message:
  Bug 2395: FTP errors not displayed
  
  * Fix PUT and other errors hanging
  * Fix assertion "entry->store_status == STORE_PENDING" caused by FTP
  * Several variable-shadowing cases resolved for the fix.
------------------------------------------------------------
# Bazaar merge directive format 2 (Bazaar 0.90)
# revision_id: squid3@treenet.co.nz-20091216010125-npa9v932f8x4pv9z
# target_branch: http://www.squid-cache.org/bzr/squid3/trunk/
# testament_sha1: 4061f9e0f51333220fcdc2f84d706290f36bf2ac
# timestamp: 2009-12-16 01:15:34 +0000
# source_branch: http://www.squid-cache.org/bzr/squid3/branches\
#   /SQUID_3_1
# base_revision_id: squid3@treenet.co.nz-20091216005917-\
#   97kq9m4r5whfqdft
# 
# Begin patch
=== modified file 'src/ftp.cc'
--- src/ftp.cc	2009-11-21 11:01:43 +0000
+++ src/ftp.cc	2009-12-16 01:01:25 +0000
@@ -3633,10 +3633,11 @@
 void
 FtpStateData::failedErrorMessage(err_type error, int xerrno)
 {
-    ErrorState *err;
+    ErrorState *ftperr;
     const char *command, *reply;
+
     /* Translate FTP errors into HTTP errors */
-    err = NULL;
+    ftperr = NULL;
 
     switch (error) {
 
@@ -3650,12 +3651,12 @@
 
             if (ctrl.replycode > 500)
                 if (password_url)
-                    err = errorCon(ERR_FTP_FORBIDDEN, HTTP_FORBIDDEN, fwd->request);
+                    ftperr = errorCon(ERR_FTP_FORBIDDEN, HTTP_FORBIDDEN, fwd->request);
                 else
-                    err = errorCon(ERR_FTP_FORBIDDEN, HTTP_UNAUTHORIZED, fwd->request);
+                    ftperr = errorCon(ERR_FTP_FORBIDDEN, HTTP_UNAUTHORIZED, fwd->request);
 
             else if (ctrl.replycode == 421)
-                err = errorCon(ERR_FTP_UNAVAILABLE, HTTP_SERVICE_UNAVAILABLE, fwd->request);
+                ftperr = errorCon(ERR_FTP_UNAVAILABLE, HTTP_SERVICE_UNAVAILABLE, fwd->request);
 
             break;
 
@@ -3663,7 +3664,7 @@
 
         case SENT_RETR:
             if (ctrl.replycode == 550)
-                err = errorCon(ERR_FTP_NOT_FOUND, HTTP_NOT_FOUND, fwd->request);
+                ftperr = errorCon(ERR_FTP_NOT_FOUND, HTTP_NOT_FOUND, fwd->request);
 
             break;
 
@@ -3674,20 +3675,20 @@
         break;
 
     case ERR_READ_TIMEOUT:
-        err = errorCon(error, HTTP_GATEWAY_TIMEOUT, fwd->request);
+        ftperr = errorCon(error, HTTP_GATEWAY_TIMEOUT, fwd->request);
         break;
 
     default:
-        err = errorCon(error, HTTP_BAD_GATEWAY, fwd->request);
+        ftperr = errorCon(error, HTTP_BAD_GATEWAY, fwd->request);
         break;
     }
 
-    if (err == NULL)
-        err = errorCon(ERR_FTP_FAILURE, HTTP_BAD_GATEWAY, fwd->request);
-
-    err->xerrno = xerrno;
-
-    err->ftp.server_msg = ctrl.message;
+    if (ftperr == NULL)
+        ftperr = errorCon(ERR_FTP_FAILURE, HTTP_BAD_GATEWAY, fwd->request);
+
+    ftperr->xerrno = xerrno;
+
+    ftperr->ftp.server_msg = ctrl.message;
 
     ctrl.message = NULL;
 
@@ -3705,12 +3706,13 @@
         reply = ctrl.last_reply;
 
     if (command)
-        err->ftp.request = xstrdup(command);
+        ftperr->ftp.request = xstrdup(command);
 
     if (reply)
-        err->ftp.reply = xstrdup(reply);
+        ftperr->ftp.reply = xstrdup(reply);
 
-    fwd->fail(err);
+    entry->replaceHttpReply( ftperr->BuildHttpReply() );
+    errorStateFree(ftperr);
 }
 
 /// \ingroup ServerProtocolFTPInternal
@@ -3752,7 +3754,8 @@
     else
         err->ftp.reply = xstrdup("");
 
-    errorAppendEntry(ftpState->entry, err);
+    ftpState->entry->replaceHttpReply( err->BuildHttpReply() );
+    errorStateFree(err);
 
     ftpSendQuit(ftpState);
 }

